# coding: utf-8
# Copyright 2023 OpenSPG Authors
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
# in compliance with the License. You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software distributed under the License
# is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
# or implied.


"""
    knext

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from knext.common.rest.configuration import Configuration


class ExpendOneHopResponse(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        "vertex": "VertexRecord",
        "edges": "list[EdgeRecord]",
        "adjacent_vertices": "list[VertexRecord]",
    }

    attribute_map = {
        "vertex": "vertex",
        "edges": "edges",
        "adjacent_vertices": "adjacentVertices",
    }

    def __init__(
        self,
        vertex=None,
        edges=None,
        adjacent_vertices=None,
        local_vars_configuration=None,
    ):  # noqa: E501
        """ExpendOneHopResponse - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._vertex = None
        self._edges = None
        self._adjacent_vertices = None
        self.discriminator = None

        if vertex is not None:
            self.vertex = vertex
        if edges is not None:
            self.edges = edges
        if adjacent_vertices is not None:
            self.adjacent_vertices = adjacent_vertices

    @property
    def vertex(self):
        """Gets the vertex of this ExpendOneHopResponse.  # noqa: E501


        :return: The vertex of this ExpendOneHopResponse.  # noqa: E501
        :rtype: VertexRecord
        """
        return self._vertex

    @vertex.setter
    def vertex(self, vertex):
        """Sets the vertex of this ExpendOneHopResponse.


        :param vertex: The vertex of this ExpendOneHopResponse.  # noqa: E501
        :type: VertexRecord
        """

        self._vertex = vertex

    @property
    def edges(self):
        """Gets the edges of this ExpendOneHopResponse.  # noqa: E501


        :return: The edges of this ExpendOneHopResponse.  # noqa: E501
        :rtype: list[EdgeRecord]
        """
        return self._edges

    @edges.setter
    def edges(self, edges):
        """Sets the edges of this ExpendOneHopResponse.


        :param edges: The edges of this ExpendOneHopResponse.  # noqa: E501
        :type: list[EdgeRecord]
        """

        self._edges = edges

    @property
    def adjacent_vertices(self):
        """Gets the adjacent_vertices of this ExpendOneHopResponse.  # noqa: E501


        :return: The adjacent_vertices of this ExpendOneHopResponse.  # noqa: E501
        :rtype: list[VertexRecord]
        """
        return self._adjacent_vertices

    @adjacent_vertices.setter
    def adjacent_vertices(self, adjacent_vertices):
        """Sets the adjacent_vertices of this ExpendOneHopResponse.


        :param adjacent_vertices: The adjacent_vertices of this ExpendOneHopResponse.  # noqa: E501
        :type: list[VertexRecord]
        """

        self._adjacent_vertices = adjacent_vertices

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ExpendOneHopResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ExpendOneHopResponse):
            return True

        return self.to_dict() != other.to_dict()
