# coding: utf-8
# Copyright 2023 OpenSPG Authors
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
# in compliance with the License. You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software distributed under the License
# is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
# or implied.


"""
    knext

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from knext.common.rest.configuration import Configuration


class VertexRecord(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        "record_type": "str",
        "vertex_type": "str",
        "id": "str",
        "properties": "list[LpgPropertyRecord]",
    }

    attribute_map = {
        "record_type": "recordType",
        "vertex_type": "vertexType",
        "id": "id",
        "properties": "properties",
    }

    def __init__(
        self,
        record_type=None,
        vertex_type=None,
        id=None,
        properties=None,
        local_vars_configuration=None,
    ):  # noqa: E501
        """VertexRecord - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._record_type = None
        self._vertex_type = None
        self._id = None
        self._properties = None
        self.discriminator = None

        if record_type is not None:
            self.record_type = record_type
        if vertex_type is not None:
            self.vertex_type = vertex_type
        if id is not None:
            self.id = id
        if properties is not None:
            self.properties = properties

    @property
    def record_type(self):
        """Gets the record_type of this VertexRecord.  # noqa: E501


        :return: The record_type of this VertexRecord.  # noqa: E501
        :rtype: str
        """
        return self._record_type

    @record_type.setter
    def record_type(self, record_type):
        """Sets the record_type of this VertexRecord.


        :param record_type: The record_type of this VertexRecord.  # noqa: E501
        :type: str
        """

        self._record_type = record_type

    @property
    def vertex_type(self):
        """Gets the vertex_type of this VertexRecord.  # noqa: E501


        :return: The vertex_type of this VertexRecord.  # noqa: E501
        :rtype: str
        """
        return self._vertex_type

    @vertex_type.setter
    def vertex_type(self, vertex_type):
        """Sets the vertex_type of this VertexRecord.


        :param vertex_type: The vertex_type of this VertexRecord.  # noqa: E501
        :type: str
        """

        self._vertex_type = vertex_type

    @property
    def id(self):
        """Gets the id of this VertexRecord.  # noqa: E501


        :return: The id of this VertexRecord.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this VertexRecord.


        :param id: The id of this VertexRecord.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def properties(self):
        """Gets the properties of this VertexRecord.  # noqa: E501


        :return: The properties of this VertexRecord.  # noqa: E501
        :rtype: list[LpgPropertyRecord]
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this VertexRecord.


        :param properties: The properties of this VertexRecord.  # noqa: E501
        :type: list[LpgPropertyRecord]
        """

        self._properties = properties

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VertexRecord):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, VertexRecord):
            return True

        return self.to_dict() != other.to_dict()
