# coding: utf-8
# Copyright 2023 OpenSPG Authors
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
# in compliance with the License. You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software distributed under the License
# is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
# or implied.


"""
    knext

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from knext.common.rest.configuration import Configuration


class WriterGraphRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        "project_id": "int",
        "operation": "str",
        "sub_graph": "object",
        "enable_lead_to": "bool",
        "token": "str"
    }

    attribute_map = {
        "project_id": "projectId",
        "operation": "operation",
        "sub_graph": "subGraph",
        "enable_lead_to": "enableLeadTo",
        "token": "token"
    }

    def __init__(
            self,
            project_id=None,
            operation=None,
            sub_graph=None,
            enable_lead_to=None,
            token=None,
            local_vars_configuration=None,
    ):  # noqa: E501
        """WriterGraphRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._project_id = None
        self._operation = None
        self._sub_graph = None
        self._enable_lead_to = None
        self._token = None
        self.discriminator = None

        if project_id is not None:
            self.project_id = project_id
        if operation is not None:
            self.operation = operation
        if sub_graph is not None:
            self.sub_graph = sub_graph
        if enable_lead_to is not None:
            self.enable_lead_to = enable_lead_to
        if token is not None:
            self.token = token

    @property
    def project_id(self):
        """Gets the project_id of this WriterGraphRequest.  # noqa: E501


        :return: The project_id of this WriterGraphRequest.  # noqa: E501
        :rtype: int
        """
        return self._project_id

    @project_id.setter
    def project_id(self, project_id):
        """Sets the project_id of this WriterGraphRequest.


        :param project_id: The project_id of this WriterGraphRequest.  # noqa: E501
        :type: int
        """

        self._project_id = project_id

    @property
    def operation(self):
        """Gets the operation of this WriterGraphRequest.  # noqa: E501


        :return: The operation of this WriterGraphRequest.  # noqa: E501
        :rtype: str
        """
        return self._operation

    @operation.setter
    def operation(self, operation):
        """Sets the operation of this WriterGraphRequest.


        :param operation: The operation of this WriterGraphRequest.  # noqa: E501
        :type: str
        """

        self._operation = operation

    @property
    def sub_graph(self):
        """Gets the sub_graph of this WriterGraphRequest.  # noqa: E501


        :return: The sub_graph of this WriterGraphRequest.  # noqa: E501
        :rtype: object
        """
        return self._sub_graph

    @sub_graph.setter
    def sub_graph(self, sub_graph):
        """Sets the sub_graph of this WriterGraphRequest.


        :param sub_graph: The sub_graph of this WriterGraphRequest.  # noqa: E501
        :type: object
        """

        self._sub_graph = sub_graph

    @property
    def enable_lead_to(self):
        """Gets the enable_lead_to of this WriterGraphRequest.  # noqa: E501


        :return: The enable_lead_to of this WriterGraphRequest.  # noqa: E501
        :rtype: bool
        """
        return self._enable_lead_to

    @enable_lead_to.setter
    def enable_lead_to(self, enable_lead_to):
        """Sets the enable_lead_to of this WriterGraphRequest.


        :param enable_lead_to: The enable_lead_to of this WriterGraphRequest.  # noqa: E501
        :type: bool
        """

        self._enable_lead_to = enable_lead_to

    @property
    def token(self):
        """Gets the token of this WriterGraphRequest.  # noqa: E501


        :return: The token of this WriterGraphRequest.  # noqa: E501
        :rtype: str
        """
        return self._token

    @token.setter
    def token(self, token):
        """Sets the token of this WriterGraphRequest.


        :param token: The token of this WriterGraphRequest.  # noqa: E501
        :type: str
        """

        self._token = token

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, WriterGraphRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, WriterGraphRequest):
            return True

        return self.to_dict() != other.to_dict()
