# coding: utf-8
# Copyright 2023 OpenSPG Authors
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
# in compliance with the License. You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software distributed under the License
# is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
# or implied.


"""
    knext

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from knext.common.rest.configuration import Configuration


class OperatorOverview(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        "id": "str",
        "name": "str",
        "desc": "str",
        "type": "str",
        "lang_type": "str",
    }

    attribute_map = {
        "id": "id",
        "name": "name",
        "desc": "desc",
        "type": "type",
        "lang_type": "langType",
    }

    def __init__(
        self,
        id=None,
        name=None,
        desc=None,
        type=None,
        lang_type=None,
        local_vars_configuration=None,
    ):  # noqa: E501
        """OperatorOverview - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._name = None
        self._desc = None
        self._type = None
        self._lang_type = None
        self.discriminator = None

        self.id = id
        self.name = name
        self.desc = desc
        self.type = type
        self.lang_type = lang_type

    @property
    def id(self):
        """Gets the id of this OperatorOverview.  # noqa: E501


        :return: The id of this OperatorOverview.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this OperatorOverview.


        :param id: The id of this OperatorOverview.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this OperatorOverview.  # noqa: E501


        :return: The name of this OperatorOverview.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this OperatorOverview.


        :param name: The name of this OperatorOverview.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def desc(self):
        """Gets the desc of this OperatorOverview.  # noqa: E501


        :return: The desc of this OperatorOverview.  # noqa: E501
        :rtype: str
        """
        return self._desc

    @desc.setter
    def desc(self, desc):
        """Sets the desc of this OperatorOverview.


        :param desc: The desc of this OperatorOverview.  # noqa: E501
        :type: str
        """

        self._desc = desc

    @property
    def type(self):
        """Gets the type of this OperatorOverview.  # noqa: E501


        :return: The type of this OperatorOverview.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this OperatorOverview.


        :param type: The type of this OperatorOverview.  # noqa: E501
        :type: str
        """
        allowed_values = [
            None,
            "KNOWLEDGE_EXTRACT",
            "ENTITY_LINK",
            "PROPERTY_NORMALIZE",
            "ENTITY_FUSION",
        ]  # noqa: E501
        if (
            self.local_vars_configuration.client_side_validation
            and type not in allowed_values
        ):  # noqa: E501
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}".format(  # noqa: E501
                    type, allowed_values
                )
            )

        self._type = type

    @property
    def lang_type(self):
        """Gets the lang_type of this OperatorOverview.  # noqa: E501


        :return: The lang_type of this OperatorOverview.  # noqa: E501
        :rtype: str
        """
        return self._lang_type

    @lang_type.setter
    def lang_type(self, lang_type):
        """Sets the lang_type of this OperatorOverview.


        :param lang_type: The lang_type of this OperatorOverview.  # noqa: E501
        :type: str
        """
        allowed_values = [None, "PYTHON", "JAVA"]  # noqa: E501
        if (
            self.local_vars_configuration.client_side_validation
            and lang_type not in allowed_values
        ):  # noqa: E501
            raise ValueError(
                "Invalid value for `lang_type` ({0}), must be one of {1}".format(  # noqa: E501
                    lang_type, allowed_values
                )
            )

        self._lang_type = lang_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OperatorOverview):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, OperatorOverview):
            return True

        return self.to_dict() != other.to_dict()
