# coding: utf-8
# Copyright 2023 OpenSPG Authors
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
# in compliance with the License. You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software distributed under the License
# is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
# or implied.


"""
    knext

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from knext.common.rest.configuration import Configuration


class ThinkerTaskRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        "project_id": "int",
        "subject": "str",
        "predicate": "str",
        "object": "str",
        "mode": "str",
        "params": "str",
    }

    attribute_map = {
        "project_id": "projectId",
        "subject": "subject",
        "predicate": "predicate",
        "object": "object",
        "mode": "mode",
        "params": "params",
    }

    def __init__(
        self,
        project_id=None,
        subject=None,
        predicate=None,
        object=None,
        mode=None,
        params=None,
        local_vars_configuration=None,
    ):  # noqa: E501
        """ThinkerTaskRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._project_id = None
        self._subject = None
        self._predicate = None
        self._object = None
        self._mode = None
        self._params = None
        self.discriminator = None

        self.project_id = project_id
        if subject is not None:
            self.subject = subject
        if predicate is not None:
            self.predicate = predicate
        if object is not None:
            self.object = object
        if mode is not None:
            self.mode = mode
        if params is not None:
            self.params = params

    @property
    def project_id(self):
        """Gets the project_id of this ThinkerTaskRequest.  # noqa: E501


        :return: The project_id of this ThinkerTaskRequest.  # noqa: E501
        :rtype: int
        """
        return self._project_id

    @project_id.setter
    def project_id(self, project_id):
        """Sets the project_id of this ThinkerTaskRequest.


        :param project_id: The project_id of this ThinkerTaskRequest.  # noqa: E501
        :type: int
        """
        if (
            self.local_vars_configuration.client_side_validation and project_id is None
        ):  # noqa: E501
            raise ValueError(
                "Invalid value for `project_id`, must not be `None`"
            )  # noqa: E501

        self._project_id = project_id

    @property
    def subject(self):
        """Gets the subject of this ThinkerTaskRequest.  # noqa: E501


        :return: The subject of this ThinkerTaskRequest.  # noqa: E501
        :rtype: str
        """
        return self._subject

    @subject.setter
    def subject(self, subject):
        """Sets the subject of this ThinkerTaskRequest.


        :param subject: The subject of this ThinkerTaskRequest.  # noqa: E501
        :type: str
        """

        self._subject = subject

    @property
    def predicate(self):
        """Gets the predicate of this ThinkerTaskRequest.  # noqa: E501


        :return: The predicate of this ThinkerTaskRequest.  # noqa: E501
        :rtype: str
        """
        return self._predicate

    @predicate.setter
    def predicate(self, predicate):
        """Sets the predicate of this ThinkerTaskRequest.


        :param predicate: The predicate of this ThinkerTaskRequest.  # noqa: E501
        :type: str
        """

        self._predicate = predicate

    @property
    def object(self):
        """Gets the object of this ThinkerTaskRequest.  # noqa: E501


        :return: The object of this ThinkerTaskRequest.  # noqa: E501
        :rtype: str
        """
        return self._object

    @object.setter
    def object(self, object):
        """Sets the object of this ThinkerTaskRequest.


        :param object: The object of this ThinkerTaskRequest.  # noqa: E501
        :type: str
        """

        self._object = object

    @property
    def mode(self):
        """Gets the mode of this ThinkerTaskRequest.  # noqa: E501


        :return: The mode of this ThinkerTaskRequest.  # noqa: E501
        :rtype: str
        """
        return self._mode

    @mode.setter
    def mode(self, mode):
        """Sets the mode of this ThinkerTaskRequest.


        :param mode: The mode of this ThinkerTaskRequest.  # noqa: E501
        :type: str
        """

        self._mode = mode

    @property
    def params(self):
        """Gets the params of this ThinkerTaskRequest.  # noqa: E501


        :return: The params of this ThinkerTaskRequest.  # noqa: E501
        :rtype: str
        """
        return self._params

    @params.setter
    def params(self, params):
        """Sets the params of this ThinkerTaskRequest.


        :param params: The params of this ThinkerTaskRequest.  # noqa: E501
        :type: str
        """

        self._params = params

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ThinkerTaskRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ThinkerTaskRequest):
            return True

        return self.to_dict() != other.to_dict()
